"use strict";var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.compileControllers=void 0;const errors_js_1=require("../utils/errors.js"),logs_js_1=require("../utils/logs.js"),typescript_1=__importDefault(require("typescript")),path_1=require("path"),glob_1=__importDefault(require("glob")),get_import_js_1=require("../utils/get-import.js"),pug_1=__importDefault(require("pug")),typescript_utils_js_1=require("../utils/typescript-utils.js");function compileControllers(r,e,i,t){var a=r.getSourceFile(e),s=r.getTypeChecker(),s=_getPattern(a,s);if(0!==s.size){const n=new Map,o=(0,path_1.relative)(process.cwd(),(0,path_1.dirname)(a.fileName));s.forEach(function(e){(0,logs_js_1.info)(`Compile pattern>> ${e}`);var t=_glob(e,o);if(0===t.length)throw new Error(`Model Parser>> No file found for pattern: ${e} at ${a.fileName}`);n.set(e,_parseFiles(t,i,r))}),(0,logs_js_1.info)("Inject data>> ..."),a=_injectData(r,a,n,t),i.set(e,a)}}function _getPattern(e,t){var r;const i=new Set,a=[e];for(var s,n=0;n<a.length;)if(s=a[n++],typescript_1.default.isCallExpression(s)){if(typescript_1.default.isPropertyAccessExpression(s.expression)&&1===(null===(r=s.arguments)||void 0===r?void 0:r.length)&&"scan"===s.expression.name.getText()&&"Gridfw"===(null===(r=t.getTypeAtLocation(s.expression.expression).symbol)||void 0===r?void 0:r.name)){if(s.arguments[0].kind!==typescript_1.default.SyntaxKind.StringLiteral)throw new Error(`Expected static string as argument of Gridfw::scan. got "${s.getText()}" at ${(0,errors_js_1._errorFile)(e,s)}`);i.add(s.arguments[0].getText())}}else a.push(...s.getChildren());return i}function _glob(e,t){var r=e.slice(1,e.length-1).split(",").map(e=>(0,path_1.join)(t,e.trim()));const i=[];var a=process.cwd();for(let e=0,t=r.length;e<t;++e){var s=glob_1.default.sync(r[e]);for(let e=0,t=s.length;e<t;++e){var n=s[e];!1===i.includes(n)&&(i.push((0,path_1.normalize)((0,path_1.join)(a,n))),(0,logs_js_1.debug)("\t>",n))}}return i}function _parseFiles(r,i,a){var s={controllers:[],i18n:[]};const n=a.getCompilerOptions();for(let e=0,t=r.length;e<t;++e){var o=r[e];let t=i.get(o);if(null==t)throw new Error(`Missing file from compilation pipeline: ${o}`);const l=[];if(t=typescript_1.default.transform(t,[function(e){return parseTs(a,e,t,s,l,n)}],n).transformed[0],0<l.length){let e=typescript_1.default.factory;t=e.updateSourceFile(t,l.concat(t.statements),!1,t.referencedFiles,t.typeReferenceDirectives,t.hasNoDefaultLib,t.libReferenceDirectives)}i.set(o,t)}return s}function parseTs(e,u,f,t,r,i){const m=e.getTypeChecker(),y=u.factory;var _;let g=t.controllers;var h=t.i18n,a=void 0,s=typescript_1.default.createPrinter();return function p(c){var d,e;switch(c.kind){case typescript_1.default.SyntaxKind.ClassDeclaration:let a=c,s=a.decorators;if(null==s)break;for(let i=0,e=s.length;i<e;++i){let e=s[i].expression,t,r;if(typescript_1.default.isCallExpression(e)&&(t=m.getTypeAtLocation(e.expression))&&("route"===(r=t.symbol.name)||"controller"===r)){_={baseRoutes:_argExtractString(e.arguments,r,f,c),methods:[]},g.push(_),c=y.createClassDeclaration(s.filter((e,t)=>t!==i),a.modifiers,a.name,a.typeParameters,a.heritageClauses,a.members),c=typescript_1.default.visitEachChild(c,p,u);break}}break;case typescript_1.default.SyntaxKind.MethodDeclaration:let n=c,o=n.decorators,l=[];if(null==o)break;e:for(let i=0,e=o.length;i<e;++i){let e=o[i],t=e.expression,r;if(typescript_1.default.isCallExpression(t)&&(r=m.getTypeAtLocation(t.expression))){let e=r.symbol.name;switch(e){case"get":case"head":case"post":case"method":case"ws":if(null!==(d=n.modifiers)&&void 0!==d&&d.some(e=>e.kind===typescript_1.default.SyntaxKind.StaticKeyword))throw new Error(`Unexpected "${e.toUpperCase()}" method as static at: ${(0,errors_js_1._errorFile)(f,n)}`);_.methods.push({method:e,routes:_argExtractString(t.arguments,e,f,c),controller:{file:f.fileName,cName:n.parent.name.getText(),name:n.name.getText(),params:n.parameters.map(function(e){var t,r;if(null==e.type)throw new Error(`Expected type for argument at: ${(0,errors_js_1._errorFile)(f,e)}`);if(null==(r=(0,get_import_js_1._importName)(null!==(t=e.type.typeName)&&void 0!==t?t:e.type,m)))throw new Error(`Unexpected type: ${null===(t=e.type)||void 0===t?void 0:t.getText()} at: ${(0,errors_js_1._errorFile)(f,e)}`);return r.node=e.type,r}),returns:n.type&&(0,get_import_js_1._importName)(n.type,m)}});continue e}}l.push(e)}l.length!==o.length&&(c=y.updateMethodDeclaration(n,l,n.modifiers,n.asteriskToken,n.name,n.questionToken,n.typeParameters,n.parameters,n.type,n.body));break;case typescript_1.default.SyntaxKind.VariableStatement:if(typescript_1.default.getJSDocTags(c).some(e=>"i18n"===e.tagName.getText())){let t=c;if(null===(e=t.modifiers)||void 0===e||!e.some(e=>e.kind===typescript_1.default.SyntaxKind.ExportKeyword))throw new Error(`Expected "export" keyword on i18n variable at ${(0,errors_js_1._errorFile)(f,t)}`);let a=[];for(let r=0,i=t.declarationList.declarations,e=i.length;r<e;++r){let e=i[r],t=e.name.getText();h.push({filename:f.fileName,varname:t}),e=x(e,t),a.push(e)}a.length&&(c=y.updateVariableStatement(t,t.modifiers,y.updateVariableDeclarationList(t.declarationList,a)))}break;case typescript_1.default.SyntaxKind.SyntaxList:case typescript_1.default.SyntaxKind.SourceFile:c=typescript_1.default.visitEachChild(c,p,u)}return c};function x(e,i){return typescript_1.default.visitEachChild(e,function e(t){var r;if(typescript_1.default.isCallExpression(t)){let e=(0,get_import_js_1._importName)(t.expression,m);if(null!=e&&e.isGridfw&&"i18nPug"===e.name){let e=t.arguments[0];if(!typescript_1.default.isStringLiteral(e))throw new Error(`Expected static string as argument for "${t.expression.getText()}" at ${(0,errors_js_1._errorFile)(f,t)}`);return null!==(r=n(e.getText().slice(1,-1),i))&&void 0!==r?r:t}}else if(typescript_1.default.isTaggedTemplateExpression(t)){let e=(0,get_import_js_1._importName)(t.tag,m);if(null!=e&&e.isGridfw&&"i18nPug"===e.name){let e=t.template;if(!typescript_1.default.isNoSubstitutionTemplateLiteral(e))throw new Error(`Expected static string (No Substitution Template Literal) as argument for "${t.tag.getText()}" at ${(0,errors_js_1._errorFile)(f,t)}`);return null!==(r=n(e.getText().slice(1,-1),i))&&void 0!==r?r:t}}return typescript_1.default.visitEachChild(t,e,u)},u)}function n(e,t){null==a&&(a=y.createUniqueName("pug"),r.push(y.createExpressionStatement(y.createIdentifier("// @ts-ignore")),y.createImportDeclaration(void 0,void 0,y.createImportClause(!1,a,void 0),y.createStringLiteral("pug-runtime")))),e="|"+e.split(/\n/).join("\n|"),e=pug_1.default.compileClient(e,{name:" ",inlineRuntimeFunctions:!1,globals:[t],compileDebug:!1,debug:!1});t=typescript_1.default.createSourceFile("any",e,typescript_1.default.ScriptTarget.ESNext,!0,typescript_1.default.ScriptKind.JS),e=(0,typescript_utils_js_1.findChildByKind)(t,typescript_1.default.SyntaxKind.FunctionDeclaration);if(null!=e)return e=typescript_1.default.transform(e,[function(s){return function t(r){var e;{if(typescript_1.default.isPropertyAccessExpression(r)&&"pug"===r.expression.getText())return y.createPropertyAccessExpression(a,r.name);if(typescript_1.default.isParameter(r))return y.createParameterDeclaration(r.decorators,r.modifiers,r.dotDotDotToken,r.name,r.questionToken,null!==(e=r.type)&&void 0!==e?e:y.createKeywordTypeNode(typescript_1.default.SyntaxKind.AnyKeyword),r.initializer);if(typescript_1.default.isVariableDeclaration(r))return y.createVariableDeclaration(r.name,r.exclamationToken,null!==(e=r.type)&&void 0!==e?e:y.createKeywordTypeNode(typescript_1.default.SyntaxKind.AnyKeyword),r.initializer);if(typescript_1.default.isCallExpression(r)){let a=r.expression;if(typescript_1.default.isPropertyAccessExpression(a)&&"call"===a.name.getText()){let i=[y.createThis()];for(let e=0,t=a.expression.parameters,r=t.length;e<r;++e)i.push(y.createPropertyAccessExpression(y.createIdentifier("locals"),t[e].name.getText()));let e=typescript_1.default.visitEachChild(r,t,s);return y.updateCallExpression(e,e.expression,void 0,i)}}}return typescript_1.default.visitEachChild(r,t,s)}}],i).transformed[0],y.createIdentifier(s.printNode(typescript_1.default.EmitHint.Unspecified,e,t))}}function _argExtractString(e,i,a,s){const n=[],o=Array.from(e);for(let t=0,r=o.length;t<r;++t){let e=o[t];if(typescript_1.default.isStringLiteral(e))n.push(e.getText());else{if(!typescript_1.default.isArrayLiteralExpression(e))throw new Error(`Expected static strings as argument to "@${i}". at ${(0,errors_js_1._errorFile)(a,s)}`);o.push(...e.elements),r=o.length}}return n}function _injectData(t,r,i,a){var o=new Map;if(r=typescript_1.default.transform(r,[function(e){return _injectDataVisitor(t,e,r,i,o,a)}],t.getCompilerOptions()).transformed[0],o.size){let s=[];const l=[];let n=typescript_1.default.factory;const p=(0,path_1.relative)(process.cwd(),(0,path_1.dirname)(r.fileName));o.forEach(function(e,t){let r;var i="gridfw"===t;r=i?t:_relative(p,t.replace(/\.ts$/,""));let a=[];e.forEach(function(e,t){var r;e.isClass?(r=n.createUniqueName(t),a.push(n.createImportSpecifier(n.createIdentifier(t),r)),l.push(n.createVariableDeclaration(e.varname,void 0,void 0,n.createNewExpression(r,void 0,[])))):a.push(n.createImportSpecifier(n.createIdentifier(t),e.varname))}),s.push(n.createImportDeclaration(void 0,void 0,n.createImportClause(i,void 0,n.createNamedImports(a)),n.createStringLiteral(r)))}),l.length&&s.push(n.createVariableStatement(void 0,n.createVariableDeclarationList(l))),s.push(...r.statements),r=n.updateSourceFile(r,s,!1,r.referencedFiles,r.typeReferenceDirectives,r.hasNoDefaultLib,r.libReferenceDirectives)}return r}function _injectDataVisitor(e,r,a,s,n,u){const o=e.getTypeChecker(),f=r.factory;return function e(i){var t;if(typescript_1.default.isCallExpression(i)){if(typescript_1.default.isPropertyAccessExpression(i.expression)&&1===(null===(t=i.arguments)||void 0===t?void 0:t.length)&&"scan"===i.expression.name.getText()&&"Gridfw"===o.getTypeAtLocation(i.expression.getFirstToken()).symbol.name){let e=i.arguments[0].getText(),t=s.get(e);if(null==t)throw new Error(`Unexpected missing pattern ${e} at ${(0,errors_js_1._errorFile)(a,i)}`);let r=l(t,i.expression.getFirstToken());i=f.createCallExpression(f.createParenthesizedExpression(f.createFunctionExpression(void 0,void 0,void 0,void 0,[],void 0,f.createBlock(r,u))),void 0,[])}}else i=typescript_1.default.visitEachChild(i,e,r);return i};function l(i,s){var n=[];for(let e=0,r=i.controllers,t=r.length;e<t;++e){let t=r[e];if(0!==t.methods.length){let a;t.baseRoutes.length?(a=f.createUniqueName("route"),n.push(f.createVariableStatement(void 0,[f.createVariableDeclaration(a,void 0,void 0,f.createCallExpression(f.createPropertyAccessExpression(s,"route"),void 0,[f.createArrayLiteralExpression(t.baseRoutes.map(e=>f.createIdentifier(e)),u)]))]))):a=s;for(let r=0,i=t.methods,e=i.length;r<e;++r){let e=i[r];var o,l,p=e.controller,c=m(p.file,p.cName,!0);let t;"method"===e.method?(o=e.routes[0],l=e.routes.slice(1).map(e=>f.createIdentifier(e)),t=[f.createIdentifier(o)],0<l.length&&t.push(f.createArrayLiteralExpression(l,u))):t=0<e.routes.length?[f.createArrayLiteralExpression(e.routes.map(e=>f.createIdentifier(e)),u)]:[],p.params&&_genRouteMethod(n,t,c,p,f,u,m),n.push(f.createExpressionStatement(f.createCallExpression(f.createPropertyAccessExpression(a,e.method),void 0,t)))}}}let a=[];for(let e=0,t=i.i18n,r=t.length;e<r;++e){var d=t[e],d=m(d.filename,d.varname,!1);a.push(d)}return a.length&&n.push(f.createExpressionStatement(f.createCallExpression(f.createPropertyAccessExpression(s,f.createIdentifier("_initI18n")),void 0,a))),n}function m(e,t,r){let i=n.get(e),a;return null==i?(i=new Map,n.set(e,i),a=f.createUniqueName(t),i.set(t,{varname:a,isClass:r})):(a=null===(e=i.get(t))||void 0===e?void 0:e.varname,null==a&&(a=f.createUniqueName(t),i.set(t,{varname:a,isClass:r}))),a}}function _relative(e,t){e=(0,path_1.relative)(e,t),t=(e=e.replace(/\\/g,"/")).charAt(0);return e="."!==t&&"/"!==t?"./"+e:e}function _genRouteMethod(e,t,r,i,a,s,n){var o=i.params,l=n("gridfw","Request",!1),p=n("gridfw","Response",!1);let c=[],d=[];for(let e=0,t=o.length;e<t;++e){var u=o[e];if(u.isGridfw)switch(u.name){case"Request":d.push(a.createIdentifier("req"));break;case"Response":d.push(a.createIdentifier("resp"));break;case"Query":case"Path":u.node.typeArguments[0].kind===typescript_1.default.SyntaxKind.AnyKeyword?d.push(a.createPropertyAccessExpression(a.createIdentifier("req"),"Query"===u.name?"query":"params")):d.push(a.createIdentifier("req"));break;default:throw new Error(`Unexpected Gridfw keyword: ${u.name}`)}}n=a.createUniqueName("ref");c.push(a.createVariableStatement(void 0,[a.createVariableDeclaration(n,void 0,void 0,a.createAwaitExpression(a.createCallExpression(a.createPropertyAccessExpression(r,a.createIdentifier(i.name)),void 0,d)))])),c.push(a.createReturnStatement(n)),t.push(a.createFunctionExpression([a.createModifier(typescript_1.default.SyntaxKind.AsyncKeyword)],void 0,void 0,void 0,[a.createParameterDeclaration(void 0,void 0,void 0,"req",void 0,a.createTypeReferenceNode(l,[a.createKeywordTypeNode(typescript_1.default.SyntaxKind.AnyKeyword),a.createKeywordTypeNode(typescript_1.default.SyntaxKind.AnyKeyword)])),a.createParameterDeclaration(void 0,void 0,void 0,"resp",void 0,a.createTypeReferenceNode(p,[a.createKeywordTypeNode(typescript_1.default.SyntaxKind.AnyKeyword),a.createKeywordTypeNode(typescript_1.default.SyntaxKind.AnyKeyword)]))],void 0,a.createBlock(c,s)))}exports.compileControllers=compileControllers;