import{_errorFile}from"../utils/errors.mjs";import{debug,info}from"../utils/logs.mjs";import ts from"typescript";import{join,relative,dirname,normalize}from"path";import Glob from"glob";import{_importName}from"../utils/get-import.mjs";import Pug from"pug";import{findChildByKind}from"../utils/typescript-utils.mjs";function compileControllers(r,e,i,t){var a=r.getSourceFile(e),n=r.getTypeChecker(),n=_getPattern(a,n);if(0!==n.size){const s=new Map,o=relative(process.cwd(),dirname(a.fileName));n.forEach(function(e){info(`Compile pattern>> ${e}`);var t=_glob(e,o);if(0===t.length)throw new Error(`Model Parser>> No file found for pattern: ${e} at ${a.fileName}`);s.set(e,_parseFiles(t,i,r))}),info("Inject data>> ..."),a=_injectData(r,a,s,t),i.set(e,a)}}function _getPattern(e,t){const r=new Set,i=[e];for(var a,n=0;n<i.length;)if(a=i[n++],ts.isCallExpression(a)){if(ts.isPropertyAccessExpression(a.expression)&&1===a.arguments?.length&&"scan"===a.expression.name.getText()&&"Gridfw"===t.getTypeAtLocation(a.expression.expression).symbol?.name){if(a.arguments[0].kind!==ts.SyntaxKind.StringLiteral)throw new Error(`Expected static string as argument of Gridfw::scan. got "${a.getText()}" at ${_errorFile(e,a)}`);r.add(a.arguments[0].getText())}}else i.push(...a.getChildren());return r}function _glob(e,t){var r=e.slice(1,e.length-1).split(",").map(e=>join(t,e.trim()));const i=[];var a=process.cwd();for(let e=0,t=r.length;e<t;++e){var n=Glob.sync(r[e]);for(let e=0,t=n.length;e<t;++e){var s=n[e];!1===i.includes(s)&&(i.push(normalize(join(a,s))),debug("\t>",s))}}return i}function _parseFiles(r,i,a){var n={controllers:[],i18n:[]};const s=a.getCompilerOptions();for(let e=0,t=r.length;e<t;++e){var o=r[e];let t=i.get(o);if(null==t)throw new Error(`Missing file from compilation pipeline: ${o}`);const l=[];if(t=ts.transform(t,[function(e){return parseTs(a,e,t,n,l,s)}],s).transformed[0],0<l.length){let e=ts.factory;t=e.updateSourceFile(t,l.concat(t.statements),!1,t.referencedFiles,t.typeReferenceDirectives,t.hasNoDefaultLib,t.libReferenceDirectives)}i.set(o,t)}return n}function parseTs(e,d,m,t,r,i){const u=e.getTypeChecker(),f=d.factory;var g;let h=t.controllers;var y=t.i18n,a=void 0,n=ts.createPrinter();return function c(p){switch(p.kind){case ts.SyntaxKind.ClassDeclaration:let a=p,n=a.decorators;if(null==n)break;for(let i=0,e=n.length;i<e;++i){let e=n[i].expression,t,r;if(ts.isCallExpression(e)&&(t=u.getTypeAtLocation(e.expression))&&("route"===(r=t.symbol.name)||"controller"===r)){g={baseRoutes:_argExtractString(e.arguments,r,m,p),methods:[]},h.push(g),p=f.createClassDeclaration(n.filter((e,t)=>t!==i),a.modifiers,a.name,a.typeParameters,a.heritageClauses,a.members),p=ts.visitEachChild(p,c,d);break}}break;case ts.SyntaxKind.MethodDeclaration:let s=p,o=s.decorators,l=[];if(null==o)break;e:for(let i=0,e=o.length;i<e;++i){let e=o[i],t=e.expression,r;if(ts.isCallExpression(t)&&(r=u.getTypeAtLocation(t.expression))){let e=r.symbol.name;switch(e){case"get":case"head":case"post":case"method":case"ws":if(s.modifiers?.some(e=>e.kind===ts.SyntaxKind.StaticKeyword))throw new Error(`Unexpected "${e.toUpperCase()}" method as static at: ${_errorFile(m,s)}`);g.methods.push({method:e,routes:_argExtractString(t.arguments,e,m,p),controller:{file:m.fileName,cName:s.parent.name.getText(),name:s.name.getText(),params:s.parameters.map(function(e){var t;if(null==e.type)throw new Error(`Expected type for argument at: ${_errorFile(m,e)}`);if(null==(t=_importName(e.type.typeName??e.type,u)))throw new Error(`Unexpected type: ${e.type?.getText()} at: ${_errorFile(m,e)}`);return t.node=e.type,t}),returns:s.type&&_importName(s.type,u)}});continue e}}l.push(e)}l.length!==o.length&&(p=f.updateMethodDeclaration(s,l,s.modifiers,s.asteriskToken,s.name,s.questionToken,s.typeParameters,s.parameters,s.type,s.body));break;case ts.SyntaxKind.VariableStatement:if(ts.getJSDocTags(p).some(e=>"i18n"===e.tagName.getText())){let t=p;if(!t.modifiers?.some(e=>e.kind===ts.SyntaxKind.ExportKeyword))throw new Error(`Expected "export" keyword on i18n variable at ${_errorFile(m,t)}`);let a=[];for(let r=0,i=t.declarationList.declarations,e=i.length;r<e;++r){let e=i[r],t=e.name.getText();y.push({filename:m.fileName,varname:t}),e=x(e,t),a.push(e)}a.length&&(p=f.updateVariableStatement(t,t.modifiers,f.updateVariableDeclarationList(t.declarationList,a)))}break;case ts.SyntaxKind.SyntaxList:case ts.SyntaxKind.SourceFile:p=ts.visitEachChild(p,c,d)}return p};function x(e,r){return ts.visitEachChild(e,function e(t){if(ts.isCallExpression(t)){let e=_importName(t.expression,u);if(null!=e&&e.isGridfw&&"i18nPug"===e.name){let e=t.arguments[0];if(!ts.isStringLiteral(e))throw new Error(`Expected static string as argument for "${t.expression.getText()}" at ${_errorFile(m,t)}`);return s(e.getText().slice(1,-1),r)??t}}else if(ts.isTaggedTemplateExpression(t)){let e=_importName(t.tag,u);if(null!=e&&e.isGridfw&&"i18nPug"===e.name){let e=t.template;if(!ts.isNoSubstitutionTemplateLiteral(e))throw new Error(`Expected static string (No Substitution Template Literal) as argument for "${t.tag.getText()}" at ${_errorFile(m,t)}`);return s(e.getText().slice(1,-1),r)??t}}return ts.visitEachChild(t,e,d)},d)}function s(e,t){null==a&&(a=f.createUniqueName("pug"),r.push(f.createExpressionStatement(f.createIdentifier("// @ts-ignore")),f.createImportDeclaration(void 0,void 0,f.createImportClause(!1,a,void 0),f.createStringLiteral("pug-runtime")))),e="|"+e.split(/\n/).join("\n|"),e=Pug.compileClient(e,{name:" ",inlineRuntimeFunctions:!1,globals:[t],compileDebug:!1,debug:!1});t=ts.createSourceFile("any",e,ts.ScriptTarget.ESNext,!0,ts.ScriptKind.JS),e=findChildByKind(t,ts.SyntaxKind.FunctionDeclaration);if(null!=e)return e=ts.transform(e,[function(n){return function t(r){{if(ts.isPropertyAccessExpression(r)&&"pug"===r.expression.getText())return f.createPropertyAccessExpression(a,r.name);if(ts.isParameter(r))return f.createParameterDeclaration(r.decorators,r.modifiers,r.dotDotDotToken,r.name,r.questionToken,r.type??f.createKeywordTypeNode(ts.SyntaxKind.AnyKeyword),r.initializer);if(ts.isVariableDeclaration(r))return f.createVariableDeclaration(r.name,r.exclamationToken,r.type??f.createKeywordTypeNode(ts.SyntaxKind.AnyKeyword),r.initializer);if(ts.isCallExpression(r)){let a=r.expression;if(ts.isPropertyAccessExpression(a)&&"call"===a.name.getText()){let i=[f.createThis()];for(let e=0,t=a.expression.parameters,r=t.length;e<r;++e)i.push(f.createPropertyAccessExpression(f.createIdentifier("locals"),t[e].name.getText()));let e=ts.visitEachChild(r,t,n);return f.updateCallExpression(e,e.expression,void 0,i)}}}return ts.visitEachChild(r,t,n)}}],i).transformed[0],f.createIdentifier(n.printNode(ts.EmitHint.Unspecified,e,t))}}function _argExtractString(e,i,a,n){const s=[],o=Array.from(e);for(let t=0,r=o.length;t<r;++t){let e=o[t];if(ts.isStringLiteral(e))s.push(e.getText());else{if(!ts.isArrayLiteralExpression(e))throw new Error(`Expected static strings as argument to "@${i}". at ${_errorFile(a,n)}`);o.push(...e.elements),r=o.length}}return s}function _injectData(t,r,i,a){var o=new Map;if(r=ts.transform(r,[function(e){return _injectDataVisitor(t,e,r,i,o,a)}],t.getCompilerOptions()).transformed[0],o.size){let n=[];const l=[];let s=ts.factory;const c=relative(process.cwd(),dirname(r.fileName));o.forEach(function(e,t){let r;var i="gridfw"===t;r=i?t:_relative(c,t.replace(/\.ts$/,""));let a=[];e.forEach(function(e,t){var r;e.isClass?(r=s.createUniqueName(t),a.push(s.createImportSpecifier(s.createIdentifier(t),r)),l.push(s.createVariableDeclaration(e.varname,void 0,void 0,s.createNewExpression(r,void 0,[])))):a.push(s.createImportSpecifier(s.createIdentifier(t),e.varname))}),n.push(s.createImportDeclaration(void 0,void 0,s.createImportClause(i,void 0,s.createNamedImports(a)),s.createStringLiteral(r)))}),l.length&&n.push(s.createVariableStatement(void 0,s.createVariableDeclarationList(l))),n.push(...r.statements),r=s.updateSourceFile(r,n,!1,r.referencedFiles,r.typeReferenceDirectives,r.hasNoDefaultLib,r.libReferenceDirectives)}return r}function _injectDataVisitor(e,t,a,n,s,m){const r=e.getTypeChecker(),u=t.factory;return function e(i){if(ts.isCallExpression(i)){if(ts.isPropertyAccessExpression(i.expression)&&1===i.arguments?.length&&"scan"===i.expression.name.getText()&&"Gridfw"===r.getTypeAtLocation(i.expression.getFirstToken()).symbol.name){let e=i.arguments[0].getText(),t=n.get(e);if(null==t)throw new Error(`Unexpected missing pattern ${e} at ${_errorFile(a,i)}`);let r=o(t,i.expression.getFirstToken());i=u.createCallExpression(u.createParenthesizedExpression(u.createFunctionExpression(void 0,void 0,void 0,void 0,[],void 0,u.createBlock(r,m))),void 0,[])}}else i=ts.visitEachChild(i,e,t);return i};function o(i,n){var s=[];for(let e=0,r=i.controllers,t=r.length;e<t;++e){let t=r[e];if(0!==t.methods.length){let a;t.baseRoutes.length?(a=u.createUniqueName("route"),s.push(u.createVariableStatement(void 0,[u.createVariableDeclaration(a,void 0,void 0,u.createCallExpression(u.createPropertyAccessExpression(n,"route"),void 0,[u.createArrayLiteralExpression(t.baseRoutes.map(e=>u.createIdentifier(e)),m)]))]))):a=n;for(let r=0,i=t.methods,e=i.length;r<e;++r){let e=i[r];var o,l,c=e.controller,p=f(c.file,c.cName,!0);let t;"method"===e.method?(o=e.routes[0],l=e.routes.slice(1).map(e=>u.createIdentifier(e)),t=[u.createIdentifier(o)],0<l.length&&t.push(u.createArrayLiteralExpression(l,m))):t=0<e.routes.length?[u.createArrayLiteralExpression(e.routes.map(e=>u.createIdentifier(e)),m)]:[],c.params&&_genRouteMethod(s,t,p,c,u,m,f),s.push(u.createExpressionStatement(u.createCallExpression(u.createPropertyAccessExpression(a,e.method),void 0,t)))}}}let a=[];for(let e=0,t=i.i18n,r=t.length;e<r;++e){var d=t[e],d=f(d.filename,d.varname,!1);a.push(d)}return a.length&&s.push(u.createExpressionStatement(u.createCallExpression(u.createPropertyAccessExpression(n,u.createIdentifier("_initI18n")),void 0,a))),s}function f(e,t,r){let i=s.get(e),a;return null==i?(i=new Map,s.set(e,i),a=u.createUniqueName(t),i.set(t,{varname:a,isClass:r})):(a=i.get(t)?.varname,null==a&&(a=u.createUniqueName(t),i.set(t,{varname:a,isClass:r}))),a}}function _relative(e,t){e=relative(e,t),t=(e=e.replace(/\\/g,"/")).charAt(0);return e="."!==t&&"/"!==t?"./"+e:e}function _genRouteMethod(e,t,r,i,a,n,s){var o=i.params,l=s("gridfw","Request",!1),c=s("gridfw","Response",!1);let p=[],d=[];for(let e=0,t=o.length;e<t;++e){var m=o[e];if(m.isGridfw)switch(m.name){case"Request":d.push(a.createIdentifier("req"));break;case"Response":d.push(a.createIdentifier("resp"));break;case"Query":case"Path":m.node.typeArguments[0].kind===ts.SyntaxKind.AnyKeyword?d.push(a.createPropertyAccessExpression(a.createIdentifier("req"),"Query"===m.name?"query":"params")):d.push(a.createIdentifier("req"));break;default:throw new Error(`Unexpected Gridfw keyword: ${m.name}`)}}s=a.createUniqueName("ref");p.push(a.createVariableStatement(void 0,[a.createVariableDeclaration(s,void 0,void 0,a.createAwaitExpression(a.createCallExpression(a.createPropertyAccessExpression(r,a.createIdentifier(i.name)),void 0,d)))])),p.push(a.createReturnStatement(s)),t.push(a.createFunctionExpression([a.createModifier(ts.SyntaxKind.AsyncKeyword)],void 0,void 0,void 0,[a.createParameterDeclaration(void 0,void 0,void 0,"req",void 0,a.createTypeReferenceNode(l,[a.createKeywordTypeNode(ts.SyntaxKind.AnyKeyword),a.createKeywordTypeNode(ts.SyntaxKind.AnyKeyword)])),a.createParameterDeclaration(void 0,void 0,void 0,"resp",void 0,a.createTypeReferenceNode(c,[a.createKeywordTypeNode(ts.SyntaxKind.AnyKeyword),a.createKeywordTypeNode(ts.SyntaxKind.AnyKeyword)]))],void 0,a.createBlock(p,n)))}export{compileControllers};